## 多媒体协议与书籍
多媒体开发涉及非常多的多媒体协议，在这里整理一些常用的多媒体协议与多媒体书籍，</br>
欢迎大家补充其他相关协议与书籍，共同维护良好的开源社区。</br>

### 多媒体协议
常见的流媒体传输协议包括：RTP、SRTP、RTMP、RTCP、RTSP，流媒体应用协议有HLS、DASH，</br>
WebRTC网络传输协议有SDP、ICE、NAT、STUN、TURN等，常用视频编码协议有H264，</br>
常用的视频封装格式有mp4，关于C语言标准有C11、C17等，详细列表如下：
 |    protocol     |          download                               |     password    |
 |:----------------|:------------------------------------------------|:----------------|
 | H264            | https://pan.baidu.com/s/1I1Sfw0y8g_XQmylzWBnV6A |       vm5i      |
 | HLS             | https://pan.baidu.com/s/1cDl8FdJfioviWasApObVcg |       w5vh      |
 | RTP             | https://pan.baidu.com/s/13K1ZHXytq8_k-TT1Nu7P7g |       eg3s      |
 | SRTP            | https://pan.baidu.com/s/1fw3deX0GC3AYtzMt7RosWg |       v87w      |
 | SDP             | https://pan.baidu.com/s/10mCBI93awj4FkSOFy3_hbQ |       ks6g      |
 | RTCP            | https://pan.baidu.com/s/1Q5ZQS5Mh_D3g9JfNQ7J9sg |       c046      |
 | RTMP            | https://pan.baidu.com/s/1Vm4mi2KOdaelLcx9t426Mw |       c1wu      |
 | RTSP            | https://pan.baidu.com/s/1mxEwMaXjL4ml3jixmdr2lw |       n6hx      |
 | RTP(WebRTC)     | https://pan.baidu.com/s/1saXyutLmuBiiCRbzkmzyyQ |       8gvc      |
 | HTTP2           | https://pan.baidu.com/s/1a2LE3vkjhBpGfLALTk0YRA |       fwxk      |
 | STUN            | https://pan.baidu.com/s/1o6G80R6880rT4My6fVXtEg |       933a      |
 | ICE             | https://pan.baidu.com/s/1AEJxzf1Nflg98u35Eg3Yyg |       1u1w      |
 | NAT             | https://pan.baidu.com/s/1Kcup8UZhnF15lqgSIkNAWw |       w3oz      |
 | C11             | https://pan.baidu.com/s/1AH7-cT6jPpgkN-fcsxZiqQ |       p0ay      |
 | C17             | https://pan.baidu.com/s/1wSgao-pq5hXuzyqu4-8lLg |       pb84      |
 | MP4             | https://pan.baidu.com/s/13WrU60CYPCRshPrmLOTtKA |       fa0f      |
 | DASH            | https://pan.baidu.com/s/1-38Erd4a9mtEUKzD3GMaig |       ctz7      |
 | DASH(ISO)       | https://pan.baidu.com/s/1UnxkaPeKVIsmddaYIrADdw |       buav      |
 | H265(ITU-T)     | https://pan.baidu.com/s/1SypB6m9cQbB-IYyUy4EvFg |       n8tz      |

### 多媒体书籍
音频开发书籍包括：音乐理论、音频信号处理与编码、DSP语音降噪、3D声音环绕，</br>
视频开发书籍包括：数字图像与视频处理、视频编码全角度详解，</br>
渲染方面是OpenGL，硬件加速指令有neon，详细列表如下：
 |    book         |          download                               |     password    |
 |:----------------|:------------------------------------------------|:----------------|
 | OpenGL          | https://pan.baidu.com/s/1j8_UD217vNeV6SWi5G3ySw |       snvo      |
 | Theory of Music | https://pan.baidu.com/s/1pDpChcrhqOUBL8Dl9xq8UQ |       b38b      |
 | neon guide      | https://pan.baidu.com/s/1mOTnhIyulNASN90IAzHzdA |       f2bw      |
 | CodingForNeon   | https://pan.baidu.com/s/1R-Lf94AnHk_hUwZQyLuxSQ |       5iyj      |
 | HybridReverb    | https://pan.baidu.com/s/19LV36iTBKPGFDQZkoCosiw |       jjlq      |
 | 数字图像与视频处理 | https://pan.baidu.com/s/1oBAtwAFU0pfnhf_cQUs6dg |       pi17      |
 | 视频编码全角度详解 | https://pan.baidu.com/s/1WBdEFF4MWcZDnheeR4XvCA |       vyfo      |
 | 音频信号处理与编码 | https://pan.baidu.com/s/1qwSrRrcs1eipph9QLxrEXg |       q9xc      |
 | DSP语音降噪      | https://pan.baidu.com/s/1z2i6vXf9xn_Uq2_T6TE8rA |       h7a1      |
 | 3D声音环绕       | https://pan.baidu.com/s/1URAnDx_eNXJhsQUSUVLKDA |       u8n0      |
 | 音视频开发进阶指南 |                      /                          |         /       |
 | 高效视频编码H.265 |                      /                          |         /       |

